
<!DOCTYPE html>

<html lang="it">
  <head>
    <meta charset="utf-8" />
    <title>Premessa &#8212; Introduzione a Sphinx 1.0.0 documentazione</title>
    <link rel="stylesheet" href="../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <script src="../_static/translations.js"></script>
    <link rel="index" title="Indice" href="../genindex.html" />
    <link rel="search" title="Cerca" href="../search.html" />
    <link rel="next" title="Installazione di Spinx" href="installazione.html" />
    <link rel="prev" title="La documentazione tecnica con Sphinx" href="../index.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="premessa">
<h1>Premessa<a class="headerlink" href="#premessa" title="Link a questa intestazione">¶</a></h1>
<div class="section" id="la-documentazione-tecnica">
<h2>La documentazione tecnica<a class="headerlink" href="#la-documentazione-tecnica" title="Link a questa intestazione">¶</a></h2>
<p>La documentazione tecnica è molto importante. Qualunque sia il progetto che
state sviluppando, la documentazione è una parte fondamentale che può
contribuire grandemente al successo.</p>
<p>Una buona documentazione tecnica dovrebbe rendere il più facile possibile
reperire le informazioni da parte dei lettori i quali possono leggere in modo
sequenziale, oppure anche cercando gli argomenti specifici di proprio
interesse.</p>
<p>Per questo motivo è necessario disporre di un buon sistema di ricerca e può
anche essere utile che siano presenti glossario ed indice analitico.alitico.</p>
<p>Il sistema deve anche essere agevole per l'autore che chiede di scrivere
rapidamente, di fare pochi errori di sintassi e di ristrutturare facilmente
i testi.</p>
</div>
<div class="section" id="strumenti">
<h2>Strumenti<a class="headerlink" href="#strumenti" title="Link a questa intestazione">¶</a></h2>
<p>Esistono molti strumenti per scrivere la documentazione ne elenchiamo alcuni
organizzati per tipologia.</p>
<div class="section" id="testo-semplice">
<h3>Testo semplice<a class="headerlink" href="#testo-semplice" title="Link a questa intestazione">¶</a></h3>
<p>Di solito il primo metodo per approcciare la documentazione è quello di
scrivere degli appunti su come desideriamo strutturare i nostri documenti.</p>
<p>Per fare questo io preferisco usare semplici files di testo da usare come
traccia per documenti più strutturati. I programmi per scrivere testo semplice
sono innumerevoli. Si fa dal più semplice &quot;Notepad&quot; presente in Windows fino
ai più sofisticati editor per programmatori. Io ultimamente preferisco
<a class="reference external" href="https://code.visualstudio.com/">Visual Studio Code</a> che oltre che per
scrivere testi semplici può essere usato come IDE per molti linguaggi di
programmazione.</p>
<p>Naturalmente questi programmi non hanno strutture per scrivere documenti
organizzati ma possono essere utili al più per testi brevi.</p>
</div>
<div class="section" id="libreoffice-e-gli-altri">
<h3>LibreOffice e gli altri<a class="headerlink" href="#libreoffice-e-gli-altri" title="Link a questa intestazione">¶</a></h3>
<p>Molti usano scrivere la documentazione con programmi di trattamento testi
come <a class="reference external" href="https://it.libreoffice.org/">LibreOffice Writer</a> oppure con sistemi
tipografici come <a class="reference external" href="https://www.scribus.net/">Scribus</a>.</p>
<p>La caratteristica principale di questi programmi è che sono orientati alla
stampa e solitamente utilizzano files in formato binario che quindi possono
essere aperti solo con il programma che li ha generati oppure con programmi
compatibili.</p>
<p>Questi programmi sono anche in grado di effettuare esportazioni in formato
html, ma il risultato è solitamente scadente e dal mio punto di vista, per
la documentazione tecnica la capacità di produrre testi html di qualità è
un fattore decisivo.</p>
</div>
<div class="section" id="html-ed-il-web">
<h3>Html ed il web<a class="headerlink" href="#html-ed-il-web" title="Link a questa intestazione">¶</a></h3>
<p>Una buona documentazione tecnica, secondo molti, dovrebbe essere scritta in
formato html, in modo da essere pubblicata nel web dove i potenziali lettori
possono trovare facilmente i documenti di proprio interesse.</p>
<p>Il linguaggio html non è complesso e nella sua versione originale era stato
pensato proprio per la produzione di documentazione tecnica.</p>
<p>Però per scrivere direttamente in formato html, si devono rispettare alcune
regole e la leggibilità diretta dei testi sorgente non è elevatissima.</p>
<p>Si deve anche considerare che nel web moderno ci sono altri componenti che
concorrono alla scrittura dei documenti che rendono più complessa la redazione
dei testi.</p>
<p>Infine nella scrittura diretta di codice html non sono disponibili gli
automatismi per la documentazione così utili a lettori e redattori.</p>
</div>
<div class="section" id="linguaggi-intermedi-markdown-e-rst">
<span id="md-ref"></span><h3>Linguaggi intermedi (Markdown e rst)<a class="headerlink" href="#linguaggi-intermedi-markdown-e-rst" title="Link a questa intestazione">¶</a></h3>
<p>Per scrivere testi html in modo più facile e leggibile sono stati sviluppati
linguaggi di markup più semplici da scrivere e leggere che possono essere
facilmente compilati per produrre testi html pronti per il web.</p>
<p>Al momento il più più diffuso ed usato è sicuramente <a class="reference external" href="https://www.markdownguide.org/">Markdown</a> che è particolarmente facile da usare.</p>
<p>Il sistema Sphinx che stiamo descrivendo è in grado di usare MarkDown ma solo
in versione basica, quindi rinunciando a molte delle funzionalità avanzate di
cui parleremo più avanti.</p>
<p>Il linguaggio di markup usato da Sphinx è <a class="reference external" href="https://docutils.sourceforge.io/rst.html/">Restructured Text</a> che probabilmente è un po' meno
intuitivo, ma ha una sintassi più ricca e può essere configurato in modo
versatile utilizzando apposite direttive.</p>
</div>
<div class="section" id="pandoc">
<span id="pandoc-ref"></span><h3>Pandoc<a class="headerlink" href="#pandoc" title="Link a questa intestazione">¶</a></h3>
<p>Parlando di linguaggi di markup e di metalinguaggi, non si può non citare
<a class="reference external" href="https://pandoc.org/">Pandoc</a> che è un sistema di traduzione automatica di
testi.</p>
<p>Con Pandoc ad esempio si può trasformare un testo MarkDown in un testo
RestructuredText o html e viceversa.</p>
<p>È quindi uno strumento utilissimo sia per traduzioni estemporanee che per
sistemi organizzati di produzione di testi.</p>
<p>Naturalmente le traduzioni vengono fatte &quot;al minimo&quot;, da una traduzione ad un
altra inevitabilmente si perdono alcune caratteristiche.</p>
<p>Per fare un esempio, se ho un libro scritto in giapponese, la traduzione in
inglese per forza di cose porterà ad una perdita semantica. Poi se lo si vuole
tradurre anche in italiano, se si parte dalla traduzione inglese si avrà una
perdita ulteriore, se invece si parte dal originale la perdita sarà minore,
ma sarà comunque inevitabile.</p>
</div>
<div class="section" id="siti-statici">
<h3>Siti statici<a class="headerlink" href="#siti-statici" title="Link a questa intestazione">¶</a></h3>
<p>Negli ultimi periodi sono comparsi sistemi per realizzare siti statici come ad
esempio <a class="reference external" href="https://gohugo.io/">Hugo</a> o <a class="reference external" href="https://www.staticgen.com/">altri</a>
in grado di produrre interi siti web a partire da testi MarkDown o
RestructuredText ed a files di configurazione.</p>
<p>Lo scopo principale dei generatori di siti, normalmente, non è quello di
produrre siti di documentazione, anche se a volte vengono usati anche per
questo, ma quello di produrre siti esteticamente accettabili con sezioni
dedicate ai blog e che al contempo abbiano pochi requisiti dal lato server
per favorire prestazioni e manutenibilità.</p>
</div>
</div>
<div class="section" id="sphinx">
<h2>Sphinx<a class="headerlink" href="#sphinx" title="Link a questa intestazione">¶</a></h2>
<p><a class="reference external" href="https://www.sphinx-doc.org/en/master/index.html">Sphinx</a> è tecnicamente
un generatore di siti statici, ma a differenza dei precedenti è orientato alla
produzione di documentazione tecnica.</p>
<p>È scritto linguaggio <a class="reference external" href="https://www.python.org/">Python</a> perciò è naturalmente
orientato alla scrittura di documentazione su librerie Python ma viene
apprezzato anche per altri tipi di documentazione.</p>
<p>È un prodotto maturo e di successo e questo è testimoniato dai molti progetti
che lo usano. La documentazione di Sphinx ne cita
<a class="reference external" href="https://www.sphinx-doc.org/en/master/examples.html">alcuni</a></p>
<p>Un altro sito degno di nota è <a class="reference external" href="https://readthedocs.org/">Read the Docs</a> che
utilizza Sphinx per ospitare moltissimi siti di documentazione. Anche in questo
caso la gran parte dei documenti si riferiscono a progetti che fanno parte
dell'ecosistema Python ma non mancano documenti tecnici generici. Ecco alcuni
esempi.</p>
<p><a class="reference external" href="https://readthedocs.org/projects/bootstrap-datepicker/">https://readthedocs.org/projects/bootstrap-datepicker/</a></p>
<p><a class="reference external" href="https://readthedocs.org/projects/scrapy/">https://readthedocs.org/projects/scrapy/</a></p>
<p>Dopo aver scritto la documentazione, è possibile scegliere l'aspetto visivo tra
vari templates disponibili. Alcuni sono integrati nel sistema, altri si
possono scaricare. Ad esempio il sito <a class="reference external" href="https://readthedocs.org/">Read the Docs</a> di cui abbiamo parlato prima ha sviluppato un
proprio template che riscuote un discreto successo.</p>
<p>Anche in questo caso i templates non possono competere esteticamente con i temi
di famosi sistemi orientati ai siti web, ma sicuramente offrono il massimo
dell'efficacia per lo scopo che si prefiggono mettendo a disposizione dei
lettori una esperienza visiva gradevole ed una navigazione efficiente delle
informazioni.</p>
<p>Un'altra caratteristica di Sphinx è che è in grado di produrre documenti anche
in formati diversi come <em>pdf</em>, <em>epub</em> ed altri ed anche a partire dagli stessi
sorgenti, quindi si possono ottenere contemporaneamente più formati.</p>
</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">Introduzione a Sphinx</a></h1>








<h3>Navigazione</h3>
<p class="caption"><span class="caption-text">Contenuto:</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Premessa</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#la-documentazione-tecnica">La documentazione tecnica</a></li>
<li class="toctree-l2"><a class="reference internal" href="#strumenti">Strumenti</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#testo-semplice">Testo semplice</a></li>
<li class="toctree-l3"><a class="reference internal" href="#libreoffice-e-gli-altri">LibreOffice e gli altri</a></li>
<li class="toctree-l3"><a class="reference internal" href="#html-ed-il-web">Html ed il web</a></li>
<li class="toctree-l3"><a class="reference internal" href="#linguaggi-intermedi-markdown-e-rst">Linguaggi intermedi (Markdown e rst)</a></li>
<li class="toctree-l3"><a class="reference internal" href="#pandoc">Pandoc</a></li>
<li class="toctree-l3"><a class="reference internal" href="#siti-statici">Siti statici</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#sphinx">Sphinx</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="installazione.html">Installazione di Spinx</a></li>
<li class="toctree-l1"><a class="reference internal" href="scrivere.html">Scrivere la documentazione</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html">MarkDown</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#configurazione">Configurazione</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#documentazione-di-python">Documentazione di Python</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#estensioni-di-sphinx">Estensioni di Sphinx</a></li>
<li class="toctree-l1"><a class="reference internal" href="glossario.html">Glossario</a></li>
<li class="toctree-l1"><a class="reference internal" href="risorse.html">Risorse</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
      <li>Previous: <a href="../index.html" title="capitolo precedente">La documentazione tecnica con Sphinx</a></li>
      <li>Next: <a href="installazione.html" title="capitolo successivo">Installazione di Spinx</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Ricerca veloce</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Vai" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2020, Claudio Driussi.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.0.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../_sources/pagine/premessa.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>